package com.wanli.web.servlet;

import com.wanli.commons.Constants;
import com.wanli.exception.UserNotFoundException;
import com.wanli.pojo.Users;
import com.wanli.service.UserLoginService;
import com.wanli.service.impl.UserLoginServiceImpl;

import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import java.io.IOException;
@WebServlet("/login.do")
public class UserLoginServlet extends HttpServlet {
    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        this.doPost(req, resp);
    }

    @Override
    protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        String username = req.getParameter("username");
        String userpwd = req.getParameter("userpwd");
        String code = req.getParameter("code");
        try {
            HttpSession session = req.getSession();
            String codeTemp = (String) session.getAttribute(Constants.VALIDATE_CODE_KEY);
            if (codeTemp.equals(code)){
                UserLoginService userLoginService = new UserLoginServiceImpl();
                Users users = userLoginService.userLogin(username,userpwd);
                //建立客户端与服务端的会话

                session.setAttribute(Constants.USER_SESSION_KEY,users);
                //使该用户只能在一个浏览器中登录，
                ServletContext servletContext = this.getServletContext();
                HttpSession temp = (HttpSession) servletContext.getAttribute(users.getUserid() + "");
                if (temp != null) {
                    servletContext.removeAttribute(users.getUserid()+"");
                    temp.invalidate();
                }
                servletContext.setAttribute(users.getUserid()+"",session);
                resp.sendRedirect("main.jsp");
            }else {
                req.setAttribute(Constants.REQUEST_MSG,"验证码有错误，请重新输入");
                req.getRequestDispatcher("login.jsp").forward(req,resp);
            }


        }catch (UserNotFoundException e){

            req.setAttribute("msg",e.getMessage());
            req.getRequestDispatcher("login.jsp").forward(req,resp);
        }catch (Exception e){
            e.printStackTrace();
            resp.sendRedirect("error.jsp");
        }
    }
}
