package com.wanli.web.servlet;

import com.wanli.dao.UserMangerDao;
import com.wanli.dao.impl.UserMangerDaoImpl;
import com.wanli.pojo.Users;
import com.wanli.service.UserMangerService;
import com.wanli.service.impl.UserMangerServiceImpl;

import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

@WebServlet("/userManager.do")
public class UserMangerServlet extends HttpServlet {
    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        this.doPost(req,resp);
    }

    @Override
    protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        String flag = req.getParameter("flag");
        if ("addUser".equals(flag)) {
            this.addUser(req,resp);
        }else if ("findUser".equals(flag)){
            this.findUser(req,resp);
        }
    }

    //处理添加用户的请求
    private void addUser(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        try {
            Users users = this.createUsers(req);
            UserMangerService userMangerService = new UserMangerServiceImpl();
            userMangerService.addUser(users);
            resp.sendRedirect("ok.jsp");
        }catch (Exception e){
            e.printStackTrace();
            resp.sendRedirect("error.jsp");
        }

    }
    //获取用户提交的数据
    private Users createUsers(HttpServletRequest req){
        String username = req.getParameter("username");
        String userpwd = req.getParameter("userpwd");
        String usersex = req.getParameter("usersex");
        String phonenumber = req.getParameter("phonenumber");
        String qqnumber = req.getParameter("qqnumber");
        Users users = new Users();
        users.setUsername(username);
        users.setUserpwd(userpwd);
        users.setQqnumber(qqnumber);
        users.setPhonenumber(phonenumber);
        users.setUsersex(usersex);
        return users;
    }

    //创建查询用户请求
    private void findUser(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        Users user = this.createUsers(req);
        try {
            UserMangerService userMangerService = new UserMangerServiceImpl();
            List<Users> list = userMangerService.findUsers(user);
            req.setAttribute("list",list);
            req.getRequestDispatcher("usermanger/viewUser.jsp").forward(req,resp);
        }catch (Exception e){
            e.printStackTrace();
            resp.sendRedirect("error.jsp");
        }
    }
}
